﻿Imports Syncfusion.JavaScript
Imports Syncfusion.JavaScript.Olap
Imports Syncfusion.Olap.Manager
Imports Syncfusion.Olap.Reports
Imports System
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data
Imports System.Data.SqlServerCe
Imports System.Linq
Imports System.Net
Imports System.Net.Http
Imports System.Web
Imports System.Web.Http
Imports System.Web.Script.Serialization
Imports OLAPUTILS = Syncfusion.JavaScript.Olap

Public Class OlapClientController
    Inherits ApiController
    Private olapClientHelper As New OlapClient()
    Private chartHelper As New Syncfusion.JavaScript.PivotChart()
    Private treemapHelper As New Syncfusion.JavaScript.PivotTreeMap()
    Private serializer As New JavaScriptSerializer()
    Shared cultureIDInfoval As Integer = 1033
    Dim connectionString As String = "Data Source=http://bi.syncfusion.com/olap/msmdpump.dll; Initial Catalog=Adventure Works DW 2008 SE;"
    Private conStringforDB As String = "DataSource=" + HttpContext.Current.Server.MapPath(".").Split(New String() {"\api"}, StringSplitOptions.None)(0) + "\database\ReportsTable.sdf; Persist Security Info=False", reportTableName As String = "ReportsTable"

    <System.Web.Http.ActionName("InitializeClient")> _
    <System.Web.Http.HttpPost> _
    Public Function InitializeClient(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As OlapDataManager = Nothing
        Dim cultureIDInfo = New System.Globalization.CultureInfo(("en-US")).LCID
        cultureIDInfoval = cultureIDInfo
        DataManager = New OlapDataManager(connectionString)
        DataManager.Culture = New System.Globalization.CultureInfo((cultureIDInfo))
        DataManager.SetCurrentReport(CreateOlapReport())
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("clientParams").ToString())
    End Function

    <System.Web.Http.ActionName("InitializeGrid")> _
    <System.Web.Http.HttpPost> _
    Public Function InitializeGrid(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        If DataManager.ConnectionString.ToLower().Replace(" ", [String].Empty).Split(";"c, "="c).Contains("localeidentifier") Then
            DataManager.Culture = New System.Globalization.CultureInfo(cultureIDInfoval)
            DataManager.OverrideDefaultFormatStrings = True
        End If
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("currentReport").ToString()))
        Return If(jsonResult.ContainsKey("gridLayout"), olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("gridLayout").ToString()), olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager))
    End Function

    <System.Web.Http.ActionName("InitializeChart")> _
    <System.Web.Http.HttpPost> _
    Public Function InitializeChart(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("currentReport").ToString()))
        Return chartHelper.GetJsonData(jsonResult("action").ToString(), DataManager)
    End Function

    <System.Web.Http.ActionName("InitializeTreeMap")> _
    <System.Web.Http.HttpPost> _
    Public Function InitializeTreeMap(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("currentReport").ToString()))
        Return treemapHelper.GetJsonData(jsonResult("action").ToString(), DataManager)
    End Function

    <System.Web.Http.ActionName("DrillChart")> _
    <System.Web.Http.HttpPost> _
    Public Function DrillChart(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        Return chartHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("drilledSeries").ToString())
    End Function

    <System.Web.Http.ActionName("DrillTreeMap")> _
    <System.Web.Http.HttpPost> _
    Public Function DrillTreeMap(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        Return treemapHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("drillInfo").ToString())
    End Function

    <System.Web.Http.ActionName("FilterElement")> _
    <System.Web.Http.HttpPost> _
    Public Function FilterElement(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("clientParams").ToString())
    End Function

    <System.Web.Http.ActionName("RemoveSplitButton")> _
    <System.Web.Http.HttpPost> _
    Public Function RemoveSplitButton(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("clientParams").ToString())
    End Function

    <System.Web.Http.ActionName("FetchMemberTreeNodes")> _
    <System.Web.Http.HttpPost> _
    Public Function FetchMemberTreeNodes(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("dimensionName").ToString())
    End Function

    <System.Web.Http.ActionName("DrillGrid")> _
    <System.Web.Http.HttpPost> _
    Public Function DrillGrid(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        If DataManager.ConnectionString.ToLower().Replace(" ", [String].Empty).Split(";"c, "="c).Contains("localeidentifier") Then
            DataManager.Culture = New System.Globalization.CultureInfo(cultureIDInfoval)
            DataManager.OverrideDefaultFormatStrings = True
        End If
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("currentReport").ToString()))
        DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("cellPosition").ToString(), jsonResult("headerInfo").ToString(), jsonResult("layout").ToString())
    End Function

    <System.Web.Http.ActionName("NodeDropped")> _
    <System.Web.Http.HttpPost> _
    Public Function NodeDropped(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("dropType").ToString(), jsonResult("nodeInfo").ToString())
    End Function

    <System.Web.Http.ActionName("CubeChanged")> _
    <System.Web.Http.HttpPost> _
    Public Function CubeChanged(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("cubeName").ToString(), jsonResult("clientParams").ToString())
    End Function

    <System.Web.Http.ActionName("MeasureGroupChanged")> _
    <System.Web.Http.HttpPost> _
    Public Function MeasureGroupChanged(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("measureGroupName").ToString())
    End Function

    <System.Web.Http.ActionName("ToolbarOperations")> _
    <System.Web.Http.HttpPost> _
    Public Function ToolbarOperations(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim toolbarOperation = ""
        Dim DataManager As New OlapDataManager(connectionString)
        If (jsonResult("olapReport")) <> Nothing AndAlso Not String.IsNullOrEmpty(jsonResult("olapReport").ToString()) Then
            DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        End If
        If (jsonResult("clientReports")) <> Nothing AndAlso Not String.IsNullOrEmpty(jsonResult("clientReports").ToString()) Then
            DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        End If
        toolbarOperation = If(jsonResult("toolbarOperation") = Nothing, Nothing, jsonResult("toolbarOperation").ToString())
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, toolbarOperation, jsonResult("clientInfo").ToString())
    End Function

    <System.Web.Http.ActionName("MemberExpanded")> _
    <System.Web.Http.HttpPost> _
    Public Function MemberExpanded(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        If Not String.IsNullOrEmpty(jsonResult("olapReport").ToString()) Then
            DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        End If
        If Not String.IsNullOrEmpty(jsonResult("clientReports").ToString()) Then
            DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        End If
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, Convert.ToBoolean(jsonResult("checkedStatus").ToString()), jsonResult("parentNode").ToString(), jsonResult("tag").ToString(), jsonResult("dimensionName").ToString(), _
            jsonResult("cubeName").ToString())
    End Function

    <System.Web.Http.ActionName("UpdateReport")> _
    <System.Web.Http.HttpPost> _
    Public Function UpdateReport(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), jsonResult("clientParams").ToString(), jsonResult("olapReport").ToString(), jsonResult("clientReports").ToString())
    End Function

    <System.Web.Http.ActionName("SaveReportToDB")> _
    <System.Web.Http.HttpPost> _
    Public Function SaveReportToDB(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim con As New SqlCeConnection() With { _
            .ConnectionString = conStringforDB _
        }
        con.Open()
        Dim cmd1 As New SqlCeCommand("insert into ReportsTable Values(@ReportName,@Reports)", con)
        cmd1.Parameters.Add("@ReportName", jsonResult("reportName").ToString())
        cmd1.Parameters.Add("@Reports", OLAPUTILS.Utils.GetReportStream(jsonResult("clientReports").ToString()).ToArray())
        cmd1.ExecuteNonQuery()
        con.Close()
        Return Nothing
    End Function

    <System.Web.Http.ActionName("FetchReportListFromDB")> _
    <System.Web.Http.HttpPost> _
    Public Function FetchReportListFromDB() As Dictionary(Of String, Object)
        Dim reportNames As String = String.Empty
        For Each row As System.Data.DataRow In GetDataTable().Rows
            reportNames = If(reportNames = "", TryCast(row.ItemArray(0), String), reportNames + "__" + TryCast(row.ItemArray(0), String))
        Next
        Dim dictionary As New Dictionary(Of String, Object)()
        dictionary.Add("ReportNameList", reportNames)
        Return dictionary
    End Function

    <System.Web.Http.ActionName("LoadReportFromDB")> _
    <System.Web.Http.HttpPost> _
    Public Function LoadReportFromDB(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        Dim reportString = ""
        For Each row As DataRow In GetDataTable().Rows
            If TryCast(row.ItemArray(0), String).Equals(jsonResult("reportName").ToString()) Then
                reportString = OLAPUTILS.Utils.CompressData(TryCast(row.ItemArray(1), Byte()))
                Exit For
            End If
        Next
        DataManager.Reports = olapClientHelper.DeserializedReports(reportString)
        DataManager.SetCurrentReport(DataManager.Reports(0))
        Return olapClientHelper.GetJsonData("toolbarOperation", DataManager, "Load Report", jsonResult("reportName").ToString())
    End Function

    Private Function GetDataTable() As DataTable
        Dim con As New SqlCeConnection() With { _
            .ConnectionString = conStringforDB _
        }
        con.Open()
        Dim dSet As New DataSet()
        CType(New SqlCeDataAdapter("Select * from ReportsTable", con), SqlCeDataAdapter).Fill(dSet)
        con.Close()
        Return dSet.Tables(0)
    End Function

    <System.Web.Http.ActionName("Export")> _
    <System.Web.Http.HttpPost> _
    Public Sub Export()
        Dim args As String = HttpContext.Current.Request.Form.GetValues(0)(0)
        Dim DataManager As New OlapDataManager(connectionString)
        Dim fileName As String = "Sample"
        olapClientHelper.ExportOlapClient(DataManager, args, fileName, System.Web.HttpContext.Current.Response)
    End Sub

    <System.Web.Http.ActionName("GetMDXQuery")> _
    <System.Web.Http.HttpPost> _
    Public Function GetMDXQuery(jsonResult As Dictionary(Of String, Object)) As String
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("olapReport").ToString()))
        Return DataManager.GetMDXQuery()
    End Function

    <System.Web.Http.ActionName("ToggleAxis")> _
    <System.Web.Http.HttpPost> _
    Public Function ToggleAxis(jsonResult As Dictionary(Of String, Object)) As Dictionary(Of String, Object)
        Dim DataManager As New OlapDataManager(connectionString)
        DataManager.SetCurrentReport(OLAPUTILS.Utils.DeserializeOlapReport(jsonResult("currentReport").ToString()))
        DataManager.Reports = olapClientHelper.DeserializedReports(jsonResult("clientReports").ToString())
        DataManager.ToggleAxis(DataManager.CurrentReport)
        Return olapClientHelper.GetJsonData(jsonResult("action").ToString(), DataManager, jsonResult("clientReports").ToString())
    End Function

    Private Function CreateOlapReport() As OlapReport
        Dim olapReport As New OlapReport() With { _
            .Name = "Default Report" _
        }
        olapReport.CurrentCubeName = "Adventure Works"

        Dim measureElement As New MeasureElements()
        measureElement.Elements.Add(New MeasureElement() With { _
            .UniqueName = "[Measures].[Customer Count]" _
        })

        Dim dimensionElementRow As New DimensionElement()
        dimensionElementRow.Name = "Date"
        dimensionElementRow.AddLevel("Fiscal", "Fiscal Year")

        olapReport.SeriesElements.Add(dimensionElementRow)
        olapReport.CategoricalElements.Add(measureElement)

        Return olapReport
    End Function
End Class
